package xyz.lychee.lagfixer.libs.adventure.text.renderer;

import java.util.function.Function;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface ComponentRenderer<C> {
   @NotNull Component render(final @NotNull Component component, final @NotNull C context);

   default <T> ComponentRenderer<T> mapContext(final Function<T, C> transformer) {
      return (component, ctx) -> {
         return this.render(component, transformer.apply(ctx));
      };
   }
}
